program DCyber;
{
 Phantom CyberSpace demo
 Turbo Pascal/ASM    version (c)1994 by Jacco Bikker
 Delphi-Kylix/Pascal version (c)2001 Paul TOTH <tothpaul@free.fr>
}
uses
 windows,vga;

{$R BMP.RES} //  delphi Resource...work also under Linux :)

Type
 TBMP256=packed record

  bfType:packed array[1..2] of char;
  bfSize:LongInt;
  brReserved:LongInt;
  bgOffBits:LongInt;

  biSize:LongInt;
  biWidth:LongInt;
  biHeight:LongInt;
  biPlanes:word;
  biBitCount:word;
  biCompression:longint;
  biSizeImage:longint;
  biXPelsPerMeter:longint;
  biYPelsPerMeter:longint;
  biClrUsed:Longint;
  biClrImportant:longint;

  colors:packed array[0..255] of integer;

  data:byte;
 end;

var
 colors:packed array[0..255] of integer;
 maps  :packed array[0.. 1,0..63,0..63] of byte;
 tiles :packed array[0..59,0..31,0..31] of byte;

const
 LINES  =70;
 KIM    =29;
 SIZE   =160;
 MWIDTH =128;
 MCENTRE=64;
 DIST   =3500;
 YSHIFT =-10;

var
 quart :integer;
 done  :array[0..319] of boolean;
 height:integer;
 line1 :integer;
 line2 :integer;
 mapx  :word;
 mapy  :word;
 addx  :word;
 addy  :word;
 step  :word;
 shade :integer;
 mx,my :integer;
 floor :integer;
 ceil  :integer;
 color :integer;
 base  :integer;
 pixel :integer;
 line3 :integer;
 y     :integer;

 shades:array[0..LINES-1] of byte;
 steps :array[0..LINES-1] of word;
 trans :array[0..44,0..LINES-1] of record
         xmap:word;
         ymap:word;
         incx:word;
         incy:word;
        end;

procedure init;
 var
  r1,r:word;
  cs:array[0..360] of real;
  sn:array[0..360] of real;
  w :real;
  y1:real;
  x2,y2,x3,y3:real;
  y :integer;
  hg:byte;
 begin
{ sin & cos }
  for r:=0 to 360 do begin
   w:=(r*PI)/180;
   sn[r]:=sin(w);
   cs[r]:=cos(w);
  end;
{ for each angle }
  for r1:=0 to 44 do begin
   w :=SIZE div 2;
   r :=2*r1;
   hg:=2*LINES+KIM+3;
  { for each line }
   for y:=0 to LINES-1 do begin

    y1:=(((500*65536)/w)-3.125*65536)/(-4);

    x2:=MCENTRE*65536-(cs[r]*(SIZE div 2)*65536)/w-sn[r]*y1;
    y2:=MCENTRE*65536-(sn[r]*(SIZE div 2)*65536)/w+cs[r]*y1;

    trans[r1,y].xmap:=round(x2/MWIDTH);
    trans[r1,y].ymap:=round(y2/MWIDTH);

    x3:=MCENTRE*65536+(cs[r]*(SIZE div 2)*65536)/w-sn[r]*y1-x2;
    y3:=MCENTRE*65536+(sn[r]*(SIZE div 2)*65536)/w+cs[r]*y1-y2;

    trans[r1,y].incx:=round(x3/SIZE);
    trans[r1,y].incy:=round(y3/SIZE);

    w:=w-(SIZE/160);    { ongeveer 145 voor 65 regels }

    shades[y]:=32*(round(y1/-DIST) div 32);
    steps [y]:=round(65536/hg);
    dec(hg,2);
   end;
  end;
 end;

function addo(var a:word; b:word):boolean; assembler;
 asm
  mov edi,a
  mov ax,[edi]
  add ax,b
  mov [edi],ax
  mov al,true
  jo @yes
   mov al,false
  @yes:
 end;

function subo(var a:word; b:word):boolean; assembler;
 asm
  mov edi,a
  mov ax,[edi]
  sub ax,b
  mov [edi],ax
  mov al,true
  jo @yes
   mov al,false
  @yes:
 end;

procedure DrawInside(xm,ym,r: integer);
 var
  line,col,y:integer;
 begin
  quart:=r div 45;
  r    :=r mod 45;

  fillchar(done,sizeof(done),byte(false));

  height:=2*LINES+KIM;
  line1 :=(199-(2*LINES+KIM)+YSHIFT);
  line2 :=              (199+YSHIFT);

  for line:=0 to LINES-1 do begin

   dec(height,2); { deux lignes d'un coup }

   with trans[r,line] do begin
    case quart of
     0:begin mapx:=xm+xmap; mapy:=ym+ymap; addx:=incx; addy:=incy; end;
     1:begin mapx:=xm-ymap; mapy:=ym+xmap; addx:=incy; addy:=incx; end;
     2:begin mapx:=xm-xmap; mapy:=ym-ymap; addx:=incx; addy:=incy; end;
     3:begin mapx:=xm+ymap; mapy:=ym-xmap; addx:=incy; addy:=incx; end;
    end;
   end;

   step :=steps [line];
   shade:=shades[line];

  { mapx/y :
     FEDCBA98.76543210
     <-map-><--tile-->

     ----------<-map-> (shr 9)
     <--tile-->------- (shl 7)
  }

   mx:=mapx shr 9-31; { mapx/y are 128x128 map based }
   my:=mapy shr 9-32;
   floor:=maps[0,my,mx];
   ceil :=maps[1,my,mx];

   mapx:=(mapx shl 7) xor 32768;
   mapy:=(mapy shl 7) xor 32768;

   for col:=0 to SIZE-1 do begin

    if not done[col] then begin

     color:=tiles[floor,mapy shr 11,mapx shr 11];

     if (color=0) then begin { wall }

      done[col]:=true; { done with this column }
      base :=floor-1;
      pixel:=32*2048-1;

      for y:=0 to height+2 do begin
       color:=tiles[0,(pixel shr 11),base]+shade;
       PutPixel(2*col  ,line2-y,color);
       PutPixel(2*col+1,line2-y,color);
       dec(pixel,step);
      end;

     end else begin

      inc(color,shade);
      PutPixel(2*col  ,line2,color);
      PutPixel(2*col+1,line2,color);

      color:=tiles[ceil,mapy shr 11,mapx shr 11]+shade;
      PutPixel(2*col  ,line1,color);
      PutPixel(2*col+1,line1,color);

     end;

    end;

    case quart of
     0,3:if addo(mapx,addx) then begin
      inc(mx);
      floor:=maps[0,my,mx];
      ceil :=maps[1,my,mx];
     end;
     1,2:if subo(mapx,addx) then begin
      dec(mx);
      floor:=maps[0,my,mx];
      ceil :=maps[1,my,mx];
     end;
    end;

    case quart of
     0,1:if addo(mapy,addy) then begin
      inc(my);
      floor:=maps[0,my,mx];
      ceil :=maps[1,my,mx];
     end;
     2,3:if subo(mapy,addy) then begin
      dec(my);
      floor:=maps[0,my,mx];
      ceil :=maps[1,my,mx];
     end;
    end;

   end; { for col }

   inc(line1);
   dec(line2);

  end; { for line }

 { effacer les "trous" du fond }
  base:=((199-(LINES-YSHIFT))-KIM);
  for col:=0 to SIZE-1 do begin
   if not done[col] then begin
    pixel:=base;
    for y:=0 to KIM do begin
     Putpixel(2*col  ,base+y,0);
     Putpixel(2*col+1,base+y,0);
    end;
   end;
   //c(base,2);
  end;

 end;

procedure LoadBMP(name:pchar; var data; size:integer; palette:pointer);
 const
  RT_RCDATA=Pchar(10);
 var
  r,m:integer;
  p:^TBMP256;
 begin
  r:=FindResource(hInstance,pchar(name),RT_RCDATA);
  m:=LoadResource(hInstance,r);
  p:=LockResource(m);
  if palette<>nil then move(p.colors,palette^,256*sizeof(integer));
  move(p.data,data,size);
  FreeResource(m);
 end;

var
 x2,y2,r,v:integer;
 px,py: array[0..360] of integer;

procedure Move(d: string; r1,r2,dr,t1,t2,ds,vr1,vr2,vrs: integer);
{ Demo-sequence command parser }
begin
 if (r1<>0) or (t1<>0) or (vrs<>0) then begin
       if (r1=0) and (r2=0) then begin
          r1:=r;
          r2:=r;
          dr:=0;
       end;
       if (t1=0) and (t2=0) then begin
          t1:=v;
          t2:=v;
          ds:=0;
       end;
       if (vr1=0) and (vr2=0) then begin   {follow direction}
          vr1:=r1;
          vr2:=r2;
          vrs:=dr;
       end;
       r:=r1;
       v:=t1;
       repeat
          r:=r+dr;
          if (r>179) then r:=r-180;
          if (r<0) then r:=r+180;
          if (r=r2) then dr:=0;
          v:=v+ds;
          if (v=t2) then ds:=0;
          vr1:=vr1+vrs;
          if (vr1>179) then vr1:=vr1-180;
          if (vr1<0) then vr1:=vr1+180;
          if (vr1=vr2) then vrs:=0;
          x2:=x2+((px[r]*v) div 100);
          y2:=y2+((py[r]*v) div 100);
          //ScrollLava;
          DrawInside(x2,y2,vr1);
          Retrace;
       until ((ds=0) and (dr=0) and (vrs=0));// or keypressed;
    end else if (dr>0) then begin
       repeat
          x2:=x2+((px[r]*v) div 100);
          y2:=y2+((py[r]*v) div 100);
          dr:=dr-1;
          //ScrollLava;
          DrawInside(x2,y2,r);
          Retrace;
       until (dr=0);// or keypressed;
    end;
    //if keypressed then quit:=True;
end;

procedure FloorPixel(n,x,y: byte);
begin
   tiles[n,(y+16) mod 32,(x+16) mod 32]:=tiles[57,(y+16) mod 32,(x+16) mod 32];
end;

procedure DarkPixel(n,x,y,c: byte);
begin
   tiles[n,(y+16) mod 32,(x+16) mod 32]:=c;
end;

procedure info;
begin
 WriteLn('Phantom Cyberspace (c)1994 by Jacco Bikker');
 Writeln('Delphi version (c)2001 by Paul TOTH <tothpaul@free.fr>');
end;

type
 OffScreen=array[0..199,0..319] of byte;
var
 i,b:integer;
 off:^OffScreen;

procedure BlackBox;
 var
  by:array[0..319] of integer;
  i,c:integer;
  a1:integer;
 begin
  x2:=-1551;
  y2:=-9232;
  r:=90;
  v:=0;
  DrawInside(x2,y2,r);

 { Blok laten zakken (shit best wel moeilijk) }
  for i:=20 to 67 do by[i]:=round(4096*(((154-104)+((24/47)*(67-i)))/(178-104)));
  for i:=81 to 224 do by[i]:=round(4096*((154-104)/(178-104)));
  for i:=250 to 295 do by[i]:=round(4096*(((154-104)+((24/45)*(i-250)))/(178-104)));

  for i:=31 to 104 do begin
   for c:=20 to 295 do PutPixel(c,i,Off[i,c]);
        for c:=67 to 157 do begin
           a1:=(160-(c-66));
           if ((a1+i-31)<178) then putpixel(c,a1+i-31,1);
        end;
        for c:=158 to 247 do begin
           a1:=c-88;
           if ((a1+i-31)<178) then putpixel(c,a1+i-31,1);
        end;
        Retrace;
        Retrace;
     end;

     for i:=105 to 178 do begin
        for c:=67 to 157 do begin
           a1:=(160-(c-66));
           if ((a1+i-31)<178) then putpixel(c,a1+i-31,1);
        end;
        for c:=158 to 247 do begin
           a1:=c-88;
           if ((a1+i-31)<178) then putpixel(c,a1+i-31,1);
        end;

        for c:=20 to 67 do begin
           a1:=(((by[c]*(i-105)) shr 12)+104);
           putpixel(c,a1,off[a1,c]);
        end;
        for c:=250 to 295 do begin
           a1:=(((by[c]*(i-105)) shr 12)+104);
           putpixel(c,a1,off[a1,c]);
        end;
        a1:=(((by[81]*(i-105)) shr 12)+104);
        for c:=68 to 249 do putpixel(c,a1,off[a1,c]);
        Retrace;
        Retrace;
     end;

  maps[0,15,29]:=55;
  maps[0,15,30]:=55;
 {
  for x:=0 to 255 do meml[s3:14*1024+x shl 2]:=0;
  for x:=0 to 31 do meml[s3:x*32+13]:=2;
 }
  x2:=-1551;
  y2:=-9232;
  r:=90;
  v:=0;
 end;

begin
 AllocConsole;
 Info;
// load resources
 LoadBMP('MAPS' ,maps ,sizeof(maps) ,nil);
 LoadBMP('TILES',tiles,sizeof(tiles),@colors);
 init;
 GraphMode;

// ScreenOff;
 x2:=-1551;
 y2:=-9232;
 r:=90;
 v:=0;
 DrawInside(x2-21*512,y2,r);
 off:=GetScreen; // see BlackBox
// ScreenOn;

 SetPalette(colors);

 for i:=0 to 179 do begin
  px[i]:=round( sin(i*3.14159/90)*100);
  py[i]:=round(-cos(i*3.14159/90)*100);
 end;

 x2:=-6953;
 y2:=13417;
 r:=143;
 v:=0;

 for i:=0 to 7 do begin
  SetColor(8,50,50,55);
  SetColor(9,45,45,50);
 end;

  { Open the elevator door }
     for i:=0 to 59 do begin
        for b:=10 to 19 do begin
           DarkPixel(14,b,i div 2,12);
           DarkPixel(15,b,31-i div 2,12);
        end;
        DarkPixel(14,20,i div 2,1);
        DarkPixel(14,21,i div 2,1);
        DarkPixel(15,20,31-i div 2,1);
        DarkPixel(15,21,31-i div 2,1);
        if i<31 then begin
           for b:=0 to 9 do begin
              FloorPixel(14,b,i);
              FloorPixel(14,b,i+1);
              FloorPixel(15,b,31-i);
              FloorPixel(15,b,30-i);
           end;
           for b:=22 to 31 do begin
              FloorPixel(14,b,i);
              FloorPixel(14,b,i+1);
              FloorPixel(15,b,31-i);
              FloorPixel(15,b,30-i);
           end;
        end;
        DrawInside(x2,y2,r);
        Retrace;
     end;

 Move('Go in room ',143,138,-1,   1,  71, 2,  0,  0, 0);
 Move('Stop       ',  0,  0, 2,  70,   0,-2,  0,  0, 0);
 Move('Look left  ',138,100,-1,   0,   0, 0,  0,  0, 0);
 Move('Wait       ',  0,  0,30,   0,   0, 0,  0,  0, 0);
 Move('Look right ',100,140, 1,   0,   0, 0,  0,  0, 0);
 Move('accelerate ',140,  0, 1,   1,  71, 2,  0,  0, 0);
 Move('high speed ',  0,  0, 0,  71, 161, 2,  0,  0, 0);
 Move('corner     ',  1, 45, 2,   0,   0, 0,  0,  0, 0);
 Move('straigt    ',  0,  0,45,   0,   0, 0,  0,  0, 0);
 Move('avoid      ', 45, 32,-1,   0,   0, 0, 45, 71, 2);
 Move('           ', 32, 58, 1,   0,   0, 0, 71,111, 2);
 Move('           ', 58, 45,-1, 161, 251, 0,111, 45,-3);
 Move('           ',  0,  0,13,   0,   0, 0,  0,  0, 0);
 Move('Go artifact',  0,  0, 0, 251,   1,-10, 0,  0, 0);
 Move('See it     ',  0,  0,20,   0,   0, 0,  0,  0, 0);
 Move('Turn back  ',110, 95,-1,   1,  41, 2, 45, 10,-1);
 Move('Further    ', 95, 75,-2,  40,   0,-4, 10,  0,-1);
 Move('Turn left  ',179,169,-1,   1,  41, 4,  0,  0, 0);
 Move('Speed      ',169,141,-2,  41, 185, 4,  0,  0, 0);
 Move('Bounce     ',141,131,-1, 185, 221, 4,  0,  0, 0);
 Move('Appr. wall ',  0,  0,10,   0,   0, 0,  0,  0, 0);
 Move('Hit wall   ',131,135, 1,   0,   0, 0,  0,  0, 0);
 Move('Beng       ',  0,  0, 2,   0,   0, 0,  0,  0, 0);
  r:=45;
 Move('Stop bounce',  0,  0, 0, 216,   0,-8,135,135, 0);
 Move('go forward ',135,135, 0,   2,  42, 4,  0,  0, 0);
 Move('avoid wall ',135,150, 1,  42,  82, 2,  0,  0, 0);
 Move('           ',  0,  0, 6,   0,   0, 0,  0,  0, 0);
 Move('past wall  ',150,135,-1,   0,   0, 0,  0,  0, 0);
 Move('           ',  0,  0,10,   0,   0, 0,  0,  0, 0);
 Move('           ',135,120,-1,   0,   0, 0,  0,  0, 0);
 Move('           ',120,135, 1,   0,   0, 0,  0,  0, 0);
 Move('           ',  0,  0,17,   0,   0, 0,  0,  0, 0);
 Move('turn right ',136,178, 2,   0,   0, 0,  0,  0, 0);
 Move('go in room ',  0,  0, 0,  82, 154, 4,  0,  0, 0);
 Move('allign     ',178,  0, 1, 154, 190, 4,  0,  0, 0);
 Move('           ',  0,  0,10,   0,   0, 0,  0,  0, 0);

  v:=190;
  r:=0;
  x2:=-1402;
  y2:=-2585;
 Move('Look back  ',  0,  0, 0,   0,   0, 0,179,155,-3);
 Move('and stop   ',  0,  0, 0, 184,   0,-8,153, 90,-3);
 Move('Avoid pilar', 90, 98, 1,   1,   9, 1,  0,  0, 0);
 Move('           ',  0,  0, 0,   9,  41, 4,  0,  0, 0);
 Move('           ', 98, 92,-1,  41,  65, 4,  0,  0, 0);
 Move('           ',  0,  0, 3,   0,   0, 0,  0,  0, 0);
 Move('           ', 90,135, 3,  65,  89, 2,  0,  0, 0);
 Move('           ',  0,  0, 0,  89, 149, 4,  0,  0, 0);
 Move('           ',  0,  0, 7,   0,   0, 0,  0,  0, 0);
 Move('           ',135,157, 2,   0,   0, 0,  0,  0, 0);
 Move('           ',158, 45, 1,   0,   0, 0,  0,  0, 0);
 Move('           ',  0,  0,37,   0,   0, 0,  0,  0, 0);
 Move('           ', 45,137, 4,   0,   0, 0,  0,  0, 0);
 Move('           ',  0,  0, 0, 149, 101,-2,137, 21, 2);
 Move('           ',  0,  0, 0,  96,   0,-6, 21, 45, 2);
 Move('           ', 45, 45, 0,   1,  21, 2,  0,  0, 0);
 Move('           ',  0,  0, 2,   0,   0, 0,  0,  0, 0);
 Move('           ', 45, 90, 1,  21,  45, 1,  0,  0, 0);
 Move('           ',  0,  0, 0,  44,   0,-4,  0,  0, 0);

 BlackBox;

 Move('           ',  0,  0,20,   0,   0, 0,  0,  0, 0);
 Move('End movie  ', 90, 50,-1,  -1, -21,-2,  0,  0, 0);
 Move('           ',  0,  0, 0, -20,   0, 2,  0,  0, 0);
 Move('           ', 50, 30,-1,   2, 102, 4,  0,  0, 0);
 Move('           ', 30, 45, 1, 102, 178, 4,  0,  0, 0);
 Move('           ',  0,  0, 0, 176,   0,-8,  0,  0, 0);
 Move('           ', 45, 16,-1,   0,   0, 0,  0,  0, 0);
 Move('           ', 16, 50, 2,   0,   0, 0,  0,  0, 0);
 Move('           ', 50, 90, 2,   2, 142, 4,  0,  0, 0);
 Move('           ', 90, 45,-3,   0,   0, 0,  0,  0, 0);
 Move('           ',  0,  0,10,   0,   0, 0,  0,  0, 0);
 Move('           ', 45, 21,-3,   0,   0, 0,  0,  0, 0);
 Move('           ', 21,  0,-3,   0,   0, 0, 21,157,-4);
 Move('           ',  0,  0, 0,   0,   0, 0,157,154,-3);
 Move('           ',  0,  0, 0,   0,   0, 0,154,152,-2);
 Move('           ',  0,  0, 0,   0,   0, 0,152,151,-1);
 Move('           ',  0,  0, 0, 142, 140,-2,151,151, 0);
 Move('           ',  0,  0, 0,   0,   0, 0,151,152, 1);
 Move('           ',  0,  0, 0,   0,   0, 0,152,154, 2);
 Move('           ',  0,  0, 0,   0,   0, 0,154,  1, 3);
 Move('           ',  1, 28, 3,   0,   0, 0,  0,  0, 0);
 Move('           ',  0,  0,22,   0,   0, 0,  0,  0, 0);

  x2:=11247;
  y2:=-13750;
  r:=28;
  v:=140;
 Move('           ', 29, 45, 1, 140,  32,-3,  0,  0, 0);
 Move('           ', 45, 90, 3,   0,   0, 0,  0,  0, 0);
 Move('           ',  0,  0, 0,  32, 320, 8,  0,  0, 0);
  r:=0; {smash}
 Move('           ',  0,  0,15,   0,   0, 0, 88, 10,-6);
 Move('           ',  0,  0, 0,   0,   0, 0, 10,  6,-4);
 Move('           ',  0,  0, 0,   0,   0, 0,  6,  0,-2);
 Move('           ',179,131,-6,   0,   0, 0,  0,  0, 0);
 Move('           ',131,126,-5,   0,   0, 0,  0,  0, 0);
 Move('           ',126,122,-4,   0,   0, 0,  0,  0, 0);
 Move('           ',122,119,-3,   0,   0, 0,  0,  0, 0);
 Move('           ',119, 97,-2,   0,   0, 0,  0,  0, 0);
 Move('           ', 97, 90,-1,   0,   0, 0,  0,  0, 0);
 Move('           ',  0,  0,10,   0,   0, 0,  0,  0, 0);
 Move('           ',  0,  0, 0, 320, 264,-8,  0,  0, 0);
 Move('           ', 90, 54,-3,   0,   0, 0,  0,  0, 0);
 Move('           ', 54, 48,-2,   0,   0, 0,  0,  0, 0);
 Move('           ', 48, 45,-1,   0,   0, 0,  0,  0, 0);
 Move('           ',  0,  0, 1,   0,   0, 0,  0,  0, 0);

 for i:=0 to 319 do for y:=0 to 199 do PutPixel(i,y,2);
 for i:=0 to 63 do begin
  SetColor(2,63-i,0,0);
  Retrace;
 end;

 TextMode;
 ReadLn;
end.
